"use strict";
exports.__esModule = true;
var fs = require("fs");
var marked = require("marked");
var logger_1 = require("../../lib/logger");
var util = require("../../lib/util");
marked.setOptions({
    renderer: new marked.Renderer(),
    langPrefix: 'language-'
});
function default_1(ast, template, options, cb) {
    logger_1["default"].tpl({
        output: options.output
    }, 'OUTPUT FILE {{#cyan}}{{{output}}}{{/cyan}}');
    ast.title = options.title;
    if (options.format !== 'md') {
        if (ast.description) {
            ast.description = marked(ast.description);
        }
        util.each(ast.docs, function (val, key) {
            ast.docs[key] = marked(val);
        });
    }
    var data = options.format === 'json' ? JSON.stringify(ast, null, 4) : template(ast);
    fs.writeFile(options.output, data, options.encoding, function (err) {
        if (err) {
            return cb(err);
        }
        cb();
    });
}
exports["default"] = default_1;
