"use strict";
exports.__esModule = true;
var async = require("async");
var logger_1 = require("../lib/logger");
var readTpl_1 = require("../lib/readTpl");
function default_1(options, cb) {
    async.waterfall([
        function (cb) {
            readTpl_1["default"](['help', 'helpCmd'], cb);
        },
        function (tpl, cb) {
            options.command
                ? output(options.command, tpl.helpCmd, cb)
                : outputAll(tpl.help, cb);
        }
    ], function (err) {
        cb(err);
    });
}
exports["default"] = default_1;
function outputAll(tpl, cb) {
    logger_1["default"].log(tpl(require('./help/all')));
    cb();
}
function output(name, tpl, cb) {
    var data;
    try {
        data = require('./help/' + name);
    }
    catch (e) {
        return cb(new Error('Command not found: ' + name));
    }
    logger_1["default"].log(tpl(data));
    cb();
}
